<?php
/**
 * Created by PhpStorm.
 * User: jorgefonseca
 * Date: 09/01/14
 * Time: 10:28
 */

namespace Folha\Logic;


use Folha\Entities\Base\GpePessoa;
use Symfony\Component\Config\Definition\Exception\Exception;
use Importacao\Logic\Util\Util;

/**
 * Class Depara
 * @package Folha\Logic
 */
class Depara {

    public static $cacheOcupacoes = array();

    /**
     * @param $nrorg
     * @param $cdmatricula
     * @return number
     */
    public static function vinculo($nrorg, $cdmatricula) {

        //$cdmatricula = str_pad($cdmatricula, 6, '0', STR_PAD_LEFT);

        $migvinculom = \Folha\Entities\MigVinculom::findOneByNrorgAndCdmatricula($nrorg, trim($cdmatricula));
        if (!$migvinculom) {
            return $cdmatricula;
        }
        return $migvinculom->getNrvinculom();
    }

    /**
     * @param $nrorg
     * @param $cdmatricula
     * @return number
     */
    public static function DtAdmissaoVinculo($nrorg, $cdmatricula) {
        
        //$cdmatricula = str_pad($cdmatricula, 6, '0', STR_PAD_LEFT);

        $migvinculom = \Folha\Entities\MigVinculom::findOneByNrorgAndCdmatricula($nrorg, trim($cdmatricula));
        if (!$migvinculom) {
            return $cdmatricula;
        }

        return substr($migvinculom->getDtadmissaovinc(), 0, 10);
    }

    /**
     * @param $nrorg
     * @param $nrde
     * @return string
     */
    public static function evento($nrorg, $nrde/*, $descricao*/) {
        $depara = \Folha\Entities\MigMigramdepara::findOneByNrorgAndNmtabeladbfAndNrde($nrorg, 'EVENTO', trim($nrde));
        /*echo "<pre>";
        var_dump($depara);die;*/
		/*$depara = \Folha\Entities\FpaEventom::findOneByNrorgAndNreventom('0', trim($nrde));
		if (!is_object($depara))
			$depara = \Folha\Entities\FpaEventoh::findOneByNrorgAndNreventomrgAndNmeventoh($nrorg, trim('(MIGRADO) '.$descricao));*/
			
//        $depara = \Geral\Entities\Migramdepara::findOneByNrorgAndNmtabeladbfAndNrde($nrorg, 'EVENTO', trim($nrde));
        return (is_object($depara)) ? $depara->getNrpara() : $nrde;
    }

    /**
     * @param $nmpais
     * @return null
     */
    public static function pais($nmpais) {
        $pais = \Geral\Entities\Pais::getObjectByWhere('UPPER(NMPAIS) = ?', array(strtoupper(Util::removeCaracteresInvalidos(trim($nmpais)))));
        return  (is_object($pais)) ? $pais->getCdpais() : null;
    }

    /**
     * @param $nmmunicipio
     * @param $sgestado
     * @return null
     */
    public static function municipio($nmmunicipio, $sgestado) {
        $municipio = \Geral\Entities\Municipio::getObjectByWhere(
            'UPPER(NMMUNICIPIO) = ? AND UPPER(SGESTADO) = ?',
            array(strtoupper(Util::removeCaracteres(trim($nmmunicipio))), strtoupper(trim($sgestado)))
        );

        return (is_object($municipio)) ? $municipio->getCdmunicipio() : null;
    }

    /**
     * @param $cdintestrutura
     * @param $nrorg
     * @return null
     */
    public static function estrutura($cdintestrutura, $nrorg) {
        $estrutura = \Folha\Entities\MigEstruturam::getObjectByWhere('CDINTESTRUTURA = ? AND NRORG = ?', array(trim($cdintestrutura), $nrorg));
        return (is_object($estrutura)) ? $estrutura->getNrestruturam() : $cdintestrutura;
    }

    /**
     * @param $cdintestrutura
     * @param $nrorg
     * @return null
     */
    public static function estruturaSindical($cdintestrutura, $nrorg) {
        $nrtipoestrutura = 10;
        $estrutura = \Folha\Entities\MigEstruturam::getObjectByWhere('CDINTESTRUTURA = ? AND NRORG = ? AND NRTIPOESTRUTURA = ?', array(trim($cdintestrutura), $nrorg, $nrtipoestrutura));
        return (is_object($estrutura)) ? $estrutura->getNrestruturam() : $cdintestrutura;
    }

    /**
     * @param $tipoestrutura
     * @param $cdintestrutura
     * @param $nrorg
     * @return null
     */
    public static function tipoestrutura($tipoestrutura, $cdintestrutura, $nrorg) {

        if (!empty($tipoestrutura)) {
            return $tipoestrutura;
        }

        $estrutura = \Folha\Entities\MigEstruturam::getObjectByWhere('CDINTESTRUTURA = ? AND NRORG = ?', array(trim($cdintestrutura), $nrorg));
        return (is_object($estrutura)) ? $estrutura->getNrtipoestrutura() : null;
    }

    /**
     * @param $cdintestrutura
     * @param $nrorg
     * @return null
     */
    public static function estruturaSuperior($cdintestrutura, $nrorg) {
        $estrutura = \Folha\Entities\MigEstruturam::getObjectByWhere('CDINTESTRUTURA = ? AND NRORG = ?', array(trim($cdintestrutura), $nrorg));
        if (is_object($estrutura)) {

            $nrestrutura = $estrutura->getNrestruturam();
            // @todo utilizando comando sql pois não existe DAO para entidade HIERARQUIAORG
            $query = "SELECT NRESTRUTURAMSUP FROM MIG_HIERARQUIAORG WHERE NRORG = $nrorg AND NRESTRUTURAMREL = $nrestrutura";
            $result = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchArray($query);
            return $result[0];
        }

        return null;
    }

    /**
     * @param $cdintegracao
     * @param $nrorg
     * @return null
     */
    public static function ocupacao($cdintegracao, $nrorg) {

        /*$ocupacao = \Folha\Entities\MigOcupacaoh::getObjectByWhere('CDINTEGRACAO = ? AND NRORG = ?', array(trim($cdintegracao), $nrorg));
        return (is_object($ocupacao)) ? $ocupacao->getNrocupacaom() : $cdintegracao;*/

        if (!isset(self::$cacheOcupacoes["$cdintegracao$nrorg"])) {
            //$ocupacao = \Folha\Entities\GpeOcupacaoh::getObjectByWhere('CDINTEGRACAO = ? AND NRORG = ?', array($cdintegracao, $nrorg));
            $ocupacao = \Folha\Entities\MigOcupacaoh::getObjectByWhere('CDINTEGRACAO = ? AND NRORG = ?', array(trim($cdintegracao), $nrorg));
            self::$cacheOcupacoes["$cdintegracao$nrorg"] = (is_object($ocupacao)) ? $ocupacao->getNrocupacaom() : $cdintegracao;
        }
        
        return self::$cacheOcupacoes["$cdintegracao$nrorg"];
    }

    /**
     * @param $cdmatricula
     * @param $nrorg
     * @return null|string
     */
    public static function parcnegocio($cdmatricula, $nrorg) {
        //str_pad($linha["data"]["NR_VINCULO"], 6, '0', STR_PAD_LEFT)
        //$gpevinculom = \Folha\Entities\MigVinculom::findOneByNrorgAndCdmatricula($nrorg, trim($cdmatricula));
        $gpevinculom = \Folha\Entities\MigVinculom::getObjectByWhere('NRORG = ? AND CDMATRICULA = ?', array($nrorg, trim($cdmatricula)));

        if (is_object($gpevinculom)) {
            $nrpessoa = $gpevinculom->getNrpessoa();

            // @todo utilizando comando sql pois não existe DAO para entidade GPE_PESSOA
            $query = "SELECT NRPARCNEGOCIO FROM MIG_PESSOA WHERE NRPESSOA = $nrpessoa AND NRORG = $nrorg";
            $result = \Setforms2\Shared\Registry::getEntityManagerConnection()->fetchArray($query);
            return $result[0];
        }

        return null;
    }

}