/*
 Nome: OPERACAO_TABELA_BACKUP
 Criao: 27/04/2010 - Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE PROCEDURE OPERACAO_TABELA_BACKUP
   (P_NRSEQESPELHOTAB  IN PARAMESPELHOTAB.NRSEQESPELHOTAB%TYPE,
    P_TABELA           IN VARCHAR2,
    P_NMLINKREPLDEST   IN VARCHAR2,
    P_IDLIMPARTABDEST  IN VARCHAR2,
    P_INSEREREGISTROS  IN VARCHAR2,
    P_DTINICIAL        IN DATE,
    P_DTFINAL          IN DATE,
    P_TABELASGERAIS    IN VARCHAR2)
IS
 V_NRSQLESPELHOTAB          PARAMSQLESPTAB.NRSQLESPELHOTAB%TYPE;
 V_NRSQLPROXIMOCODIGO       VARCHAR2(20);
 V_TESTE                    VARCHAR2(20);
 V_SQLOBJETO                VARCHAR2(6000);
 V_FILTRO_DATA              VARCHAR2(6000);
 V_FILTRO_FILIAL            VARCHAR2(6000); 
 V_FILTRO_PK                VARCHAR2(6000);
 V_SELECT_REGISTRO          VARCHAR2(6000);
 V_SENTENCA_SQL             VARCHAR2(6000);
 V_SENTENCA_SQL_R           VARCHAR2(6000);
 V_CHAVE                    VARCHAR2(6000);

 V_DATA_EXISTE              DATE;

 V_ESTRUTURA_COLUMN_NAME    USER_TAB_COLUMNS.COLUMN_NAME%TYPE;
 V_ESTRUTURA_COLUMN_TIPO    USER_TAB_COLUMNS.DATA_TYPE%TYPE;
 V_ESTRUTURA_COLUMN_TAMANHO USER_TAB_COLUMNS.DATA_LENGTH%TYPE;
 V_ESTRUTURA_COLUMN_DEFAULT USER_TAB_COLUMNS.DATA_DEFAULT%TYPE;

 V_SQLOBJETO_TABLE          USER_TABLES.TABLE_NAME%TYPE;

 V_INDEX_NAME               USER_INDEXES.INDEX_NAME%TYPE;

 V_CONSTRAINT_NAME          USER_CONSTRAINTS.CONSTRAINT_NAME%TYPE;
 V_CONSTRAINT_TYPE          USER_CONSTRAINTS.CONSTRAINT_TYPE%TYPE;
 V_R_CONSTRAINT_NAME        USER_CONSTRAINTS.R_CONSTRAINT_NAME%TYPE;
 V_DELETE_RULE              USER_CONSTRAINTS.DELETE_RULE%TYPE;
 V_TABLE_REFERENCES         USER_TABLES.TABLE_NAME%TYPE;

 V_ESTRUTURA_COLUMN_NULO    VARCHAR2(10);
 V_CRIACAO_TABELA           VARCHAR2(1);

 TYPE CURTYPE               IS REF CURSOR;
 CUR_TABELAEXISTE           CURTYPE;
 CUR_ESTRUTURA_COLUMN       CURTYPE;
 CUR_INDEXES                CURTYPE;
 CUR_CONSTRAINTS            CURTYPE;
 CUR_REGISTROEXISTE         CURTYPE;
 CUR_UPDATE_LONGRAW         CURTYPE;
 CUR_PARAMGERAL             CURTYPE;

 W_N                        CHAR(1) := 'N';
 W_Y                        CHAR(1) := 'Y';
 W_NULL                     VARCHAR2(10) := 'NULL';
 W_NOTNULL                  VARCHAR2(10) := 'NOT NULL';

 V_COUNT                    FLOAT;
 V_LONGRAW                  LONG RAW;
 V_EXECUTAR                 CHAR(1) := 'S';

 V_DSCAMPDTAREANEG          TAB_AREANEGOCIO.DSCAMPDTAREANEG%TYPE;
 V_DSCAMPFILAREANEG         TAB_AREANEGOCIO.DSCAMPFILAREANEG%TYPE;
BEGIN
   IF P_INSEREREGISTROS = 'N' THEN
      V_COUNT := 0;
      SELECT COUNT(1)
      INTO V_COUNT
      FROM OBJ_ESPELHOTAB
      WHERE OBJ_ESPELHOTAB.NRSEQESPELHOTAB = P_NRSEQESPELHOTAB
        AND OBJ_ESPELHOTAB.NMOBJESPELHOTAB = P_TABELA
        AND OBJ_ESPELHOTAB.IDTIPESPELHOTAB = 'DDL';

      IF V_COUNT <= 0 THEN
         IF (P_TABELASGERAIS = 'N') THEN
            FOR C_TABELAS_FILHAS IN
               (SELECT DISTINCT
                   UC.TABLE_NAME AS TABLE_NAME
                FROM USER_CONSTRAINTS UC, USER_CONSTRAINTS UCR
                WHERE UCR.CONSTRAINT_NAME = UC.R_CONSTRAINT_NAME
                  AND UCR.TABLE_NAME = P_TABELA
                  AND UCR.CONSTRAINT_TYPE IN( 'P','U')
                  AND UC.TABLE_NAME <> P_TABELA
                  AND NOT EXISTS (SELECT 1
                                  FROM USER_TAB_COLUMNS, USER_CONS_COLUMNS
                                  WHERE USER_TAB_COLUMNS.TABLE_NAME = UC.TABLE_NAME
                                    AND USER_TAB_COLUMNS.COLUMN_NAME = USER_CONS_COLUMNS.COLUMN_NAME
                                    AND USER_CONS_COLUMNS.TABLE_NAME = UC.TABLE_NAME
                                    AND USER_CONS_COLUMNS.CONSTRAINT_NAME = UC.CONSTRAINT_NAME
                                    AND USER_CONS_COLUMNS.OWNER = UC.OWNER
                                    AND USER_TAB_COLUMNS.NULLABLE = 'Y'))
            LOOP
               OPERACAO_TABELA_BACKUP(P_NRSEQESPELHOTAB, C_TABELAS_FILHAS.TABLE_NAME, P_NMLINKREPLDEST, P_IDLIMPARTABDEST, 'N',P_DTINICIAL, P_DTFINAL, P_TABELASGERAIS);
            END LOOP;
         END IF;
         IF (P_IDLIMPARTABDEST = 'S') AND (P_TABELASGERAIS = 'N') THEN
            V_SQLOBJETO := 'SELECT TABLE_NAME '||
                           'FROM USER_TABLES@'||P_NMLINKREPLDEST||' DEST '||
                           'WHERE DEST.TABLE_NAME = '''||P_TABELA||''' ';
            OPEN CUR_TABELAEXISTE FOR V_SQLOBJETO;
            FETCH CUR_TABELAEXISTE INTO V_SQLOBJETO_TABLE;
            IF NOT (CUR_TABELAEXISTE%NOTFOUND) THEN
               NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
               V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
               V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);

               INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
               VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'DDL');

               INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
               VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                      'TRUNCATE TABLE ' || P_TABELA);
            END IF;
            CLOSE CUR_TABELAEXISTE;
         END IF;

         V_SQLOBJETO := 'SELECT TABLE_NAME '||
                        'FROM USER_TABLES@'||P_NMLINKREPLDEST||' DEST '||
                        'WHERE DEST.TABLE_NAME = '''||P_TABELA||''' ';

         OPEN CUR_TABELAEXISTE FOR V_SQLOBJETO;
         FETCH CUR_TABELAEXISTE INTO V_SQLOBJETO_TABLE;

         V_CRIACAO_TABELA := 'N';
         IF CUR_TABELAEXISTE%NOTFOUND THEN
            CLOSE CUR_TABELAEXISTE;
            V_SQLOBJETO := 'SELECT ORIGEM.COLUMN_NAME, ORIGEM.DATA_TYPE, '||
                           'DECODE(ORIGEM.NULLABLE, '''||W_Y||''', '''||W_NULL||''', '''||W_NOTNULL||'''), ORIGEM.DATA_LENGTH, ORIGEM.DATA_DEFAULT '||
                           'FROM USER_TAB_COLUMNS ORIGEM '||
                           'WHERE ORIGEM.TABLE_NAME = '''||P_TABELA||''' '||
                           ' ORDER BY ORIGEM.COLUMN_ID ';
            OPEN CUR_ESTRUTURA_COLUMN FOR V_SQLOBJETO;
            LOOP
               FETCH CUR_ESTRUTURA_COLUMN INTO V_ESTRUTURA_COLUMN_NAME, V_ESTRUTURA_COLUMN_TIPO, V_ESTRUTURA_COLUMN_NULO,
                                               V_ESTRUTURA_COLUMN_TAMANHO, V_ESTRUTURA_COLUMN_DEFAULT;
               EXIT WHEN CUR_ESTRUTURA_COLUMN%NOTFOUND;
               IF V_CRIACAO_TABELA = 'N' THEN
                  /*Criao da Tabela*/
                  NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
                  V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
                  V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);

                  INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
                  VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'DDL');

                  IF (INSTR(V_ESTRUTURA_COLUMN_TIPO, 'CHAR') > 0) OR (V_ESTRUTURA_COLUMN_TIPO = 'RAW') THEN
                     IF V_ESTRUTURA_COLUMN_DEFAULT IS NULL THEN
                        INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                        VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                               'CREATE TABLE ' || P_TABELA ||' ('|| V_ESTRUTURA_COLUMN_NAME || ' '
                                              || V_ESTRUTURA_COLUMN_TIPO||'('||V_ESTRUTURA_COLUMN_TAMANHO||') '|| DECODE(V_ESTRUTURA_COLUMN_TIPO, 'RAW',' NULL', V_ESTRUTURA_COLUMN_NULO)|| ')');
                     ELSE
                        INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                        VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                               'CREATE TABLE ' || P_TABELA ||' ('|| V_ESTRUTURA_COLUMN_NAME || ' '
                                              || V_ESTRUTURA_COLUMN_TIPO||'('||V_ESTRUTURA_COLUMN_TAMANHO||') '|| ' DEFAULT '
                                              || V_ESTRUTURA_COLUMN_DEFAULT||' '||DECODE(V_ESTRUTURA_COLUMN_TIPO, 'RAW',' NULL', V_ESTRUTURA_COLUMN_NULO)|| ')');

                     END IF;
                  ELSE
                     IF INSTR(V_ESTRUTURA_COLUMN_TIPO, 'LONG RAW') > 0 THEN
                        IF V_ESTRUTURA_COLUMN_DEFAULT IS NULL THEN
                           INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                           VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                                  'CREATE TABLE ' || P_TABELA ||' ('|| V_ESTRUTURA_COLUMN_NAME || ' '
                                                 || V_ESTRUTURA_COLUMN_TIPO ||' '||' NULL '|| ')');


                        ELSE
                           INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                           VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                                  'CREATE TABLE ' || P_TABELA ||' ('|| V_ESTRUTURA_COLUMN_NAME || ' '
                                                 || V_ESTRUTURA_COLUMN_TIPO || ' DEFAULT '
                                                 || V_ESTRUTURA_COLUMN_DEFAULT||' '||' NULL '|| ')');

                        END IF;
                     ELSE
                        IF V_ESTRUTURA_COLUMN_DEFAULT IS NULL THEN
                           INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                           VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                                  'CREATE TABLE ' || P_TABELA ||' ('|| V_ESTRUTURA_COLUMN_NAME || ' '
                                                 || V_ESTRUTURA_COLUMN_TIPO ||' '||V_ESTRUTURA_COLUMN_NULO|| ')');
                        ELSE
                           INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                           VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                                  'CREATE TABLE ' || P_TABELA ||' ('|| V_ESTRUTURA_COLUMN_NAME || ' '
                                                 || V_ESTRUTURA_COLUMN_TIPO || ' DEFAULT '
                                                 || V_ESTRUTURA_COLUMN_DEFAULT||' '||V_ESTRUTURA_COLUMN_NULO|| ')');
                        END IF;
                     END IF;
                  END IF;
                  V_CRIACAO_TABELA := 'S';
               ELSE
                  NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
                  V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
                  V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);
                  INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
                  VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'DDL');
                  IF (INSTR(V_ESTRUTURA_COLUMN_TIPO, 'CHAR') > 0) OR (V_ESTRUTURA_COLUMN_TIPO = 'RAW') THEN
                     IF V_ESTRUTURA_COLUMN_DEFAULT IS NULL THEN
                        INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                        VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                               'ALTER TABLE ' || P_TABELA ||' ADD '||V_ESTRUTURA_COLUMN_NAME || ' '
                                              || V_ESTRUTURA_COLUMN_TIPO ||'('||V_ESTRUTURA_COLUMN_TAMANHO||') '
                                              || DECODE(V_ESTRUTURA_COLUMN_TIPO, 'RAW',' NULL', V_ESTRUTURA_COLUMN_NULO));
                     ELSE
                        INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                        VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                               'ALTER TABLE ' || P_TABELA ||' ADD '||V_ESTRUTURA_COLUMN_NAME || ' '
                                              || V_ESTRUTURA_COLUMN_TIPO ||'('||V_ESTRUTURA_COLUMN_TAMANHO||') '
                                              || ' DEFAULT ' || V_ESTRUTURA_COLUMN_DEFAULT||' '
                                              || DECODE(V_ESTRUTURA_COLUMN_TIPO, 'RAW',' NULL', V_ESTRUTURA_COLUMN_NULO));
                     END IF;
                  ELSE
                     IF INSTR(V_ESTRUTURA_COLUMN_TIPO, 'LONG RAW') > 0 THEN
                        IF V_ESTRUTURA_COLUMN_DEFAULT IS NULL THEN
                           INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                           VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                                  'ALTER TABLE ' || P_TABELA ||' ADD '||V_ESTRUTURA_COLUMN_NAME || ' '
                                                 || V_ESTRUTURA_COLUMN_TIPO ||' NULL');
                        ELSE
                           INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                           VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                                  'ALTER TABLE ' || P_TABELA ||' ADD '||V_ESTRUTURA_COLUMN_NAME || ' '
                                                 || V_ESTRUTURA_COLUMN_TIPO || ' DEFAULT '
                                                 || V_ESTRUTURA_COLUMN_DEFAULT||' NULL');
                        END IF;
                     ELSE
                        IF V_ESTRUTURA_COLUMN_DEFAULT IS NULL THEN
                           INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                           VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                                  'ALTER TABLE ' || P_TABELA ||' ADD '||V_ESTRUTURA_COLUMN_NAME || ' '
                                                 || V_ESTRUTURA_COLUMN_TIPO ||' '|| V_ESTRUTURA_COLUMN_NULO);
                        ELSE
                           INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                           VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                                  'ALTER TABLE ' || P_TABELA ||' ADD '||V_ESTRUTURA_COLUMN_NAME || ' '
                                                 || V_ESTRUTURA_COLUMN_TIPO || ' DEFAULT '
                                                 || V_ESTRUTURA_COLUMN_DEFAULT||' '|| V_ESTRUTURA_COLUMN_NULO);
                        END IF;
                     END IF;
                  END IF;
               END IF;
            END LOOP;
            CLOSE CUR_ESTRUTURA_COLUMN;
         ELSE
            CLOSE CUR_TABELAEXISTE;
            V_SQLOBJETO := 'SELECT ORIGEM.COLUMN_NAME, ORIGEM.DATA_TYPE, '||
                           'DECODE(ORIGEM.NULLABLE, '''||W_Y||''', '''||W_NULL||''', '''||W_NOTNULL||'''), ORIGEM.DATA_LENGTH, ORIGEM.DATA_DEFAULT '||
                           'FROM USER_TAB_COLUMNS ORIGEM '||
                           'WHERE ORIGEM.TABLE_NAME = '''||P_TABELA||''' '||
                           '  AND NOT EXISTS (SELECT 1 '||
                           '                  FROM USER_TAB_COLUMNS@'||P_NMLINKREPLDEST||' DEST '||
                           '                  WHERE DEST.TABLE_NAME = '''||P_TABELA||''' '||
                           '                    AND DEST.COLUMN_NAME = ORIGEM.COLUMN_NAME) '||
                           'ORDER BY ORIGEM.COLUMN_ID ';
            OPEN CUR_ESTRUTURA_COLUMN FOR V_SQLOBJETO;
            LOOP
               FETCH CUR_ESTRUTURA_COLUMN INTO V_ESTRUTURA_COLUMN_NAME, V_ESTRUTURA_COLUMN_TIPO, V_ESTRUTURA_COLUMN_NULO,
                                               V_ESTRUTURA_COLUMN_TAMANHO, V_ESTRUTURA_COLUMN_DEFAULT;
               EXIT WHEN CUR_ESTRUTURA_COLUMN%NOTFOUND;
               NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
               V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
               V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);
               INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
               VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'DDL');


               IF (INSTR(V_ESTRUTURA_COLUMN_TIPO, 'CHAR') > 0) OR (V_ESTRUTURA_COLUMN_TIPO = 'RAW') THEN
                  IF V_ESTRUTURA_COLUMN_DEFAULT IS NULL THEN
                     INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                     VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                            'ALTER TABLE ' || P_TABELA ||' ADD '||V_ESTRUTURA_COLUMN_NAME || ' '
                                           || V_ESTRUTURA_COLUMN_TIPO ||'('||V_ESTRUTURA_COLUMN_TAMANHO||') '
                                           || DECODE(V_ESTRUTURA_COLUMN_TIPO, 'RAW',' NULL', V_ESTRUTURA_COLUMN_NULO));
                  ELSE
                     INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                     VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                            'ALTER TABLE ' || P_TABELA ||' ADD '||V_ESTRUTURA_COLUMN_NAME || ' '
                                           || V_ESTRUTURA_COLUMN_TIPO ||'('||V_ESTRUTURA_COLUMN_TAMANHO||') '
                                           || ' DEFAULT ' || V_ESTRUTURA_COLUMN_DEFAULT||' '
                                           || DECODE(V_ESTRUTURA_COLUMN_TIPO, 'RAW',' NULL', V_ESTRUTURA_COLUMN_NULO));
                  END IF;
               ELSE
                  IF INSTR(V_ESTRUTURA_COLUMN_TIPO, 'LONG RAW') > 0 THEN
                     IF V_ESTRUTURA_COLUMN_DEFAULT IS NULL THEN
                        INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                        VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                               'ALTER TABLE ' || P_TABELA ||' ADD '||V_ESTRUTURA_COLUMN_NAME || ' '
                                              || V_ESTRUTURA_COLUMN_TIPO ||' NULL');
                     ELSE
                        INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                        VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                               'ALTER TABLE ' || P_TABELA ||' ADD '||V_ESTRUTURA_COLUMN_NAME || ' '
                                              || V_ESTRUTURA_COLUMN_TIPO || ' DEFAULT '
                                              || V_ESTRUTURA_COLUMN_DEFAULT||' NULL');
                     END IF;
                  ELSE
                     IF V_ESTRUTURA_COLUMN_DEFAULT IS NULL THEN
                        INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                        VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                               'ALTER TABLE ' || P_TABELA ||' ADD '||V_ESTRUTURA_COLUMN_NAME || ' '
                                              || V_ESTRUTURA_COLUMN_TIPO ||' '|| V_ESTRUTURA_COLUMN_NULO);
                     ELSE
                        INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
                        VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                               'ALTER TABLE ' || P_TABELA ||' ADD '||V_ESTRUTURA_COLUMN_NAME || ' '
                                              || V_ESTRUTURA_COLUMN_TIPO || ' DEFAULT '
                                              || V_ESTRUTURA_COLUMN_DEFAULT||' '|| V_ESTRUTURA_COLUMN_NULO);
                     END IF;
                  END IF;
               END IF;
            END LOOP;
            CLOSE CUR_ESTRUTURA_COLUMN;
         END IF;

         V_SQLOBJETO := 'SELECT CONSTRAINT_NAME, CONSTRAINT_TYPE '||
                        'FROM USER_CONSTRAINTS ORIGEM '||
                        'WHERE ORIGEM.TABLE_NAME = '''||P_TABELA||''' '||
                        '  AND ORIGEM.CONSTRAINT_TYPE IN ('''||'P'||''', ''' ||'U'||''') '||
                        '  AND NOT EXISTS (SELECT 1 '||
                        '                  FROM USER_CONSTRAINTS@'||P_NMLINKREPLDEST||' DEST '||
                        '                  WHERE DEST.TABLE_NAME = '''||P_TABELA||''' '||
                        '                    AND DEST.CONSTRAINT_NAME = ORIGEM.CONSTRAINT_NAME) ';

         OPEN CUR_CONSTRAINTS FOR V_SQLOBJETO;
         LOOP
            FETCH CUR_CONSTRAINTS INTO V_CONSTRAINT_NAME, V_CONSTRAINT_TYPE;
            EXIT WHEN CUR_CONSTRAINTS%NOTFOUND;
            V_SENTENCA_SQL := NULL;
            FOR C_COLUMN_CONSTRAINTS IN
               (SELECT COLUMN_NAME
                FROM USER_CONS_COLUMNS
                WHERE CONSTRAINT_NAME = V_CONSTRAINT_NAME
                  AND TABLE_NAME = P_TABELA
                ORDER BY USER_CONS_COLUMNS.POSITION)
            LOOP
               IF V_SENTENCA_SQL IS NULL THEN
                  V_SENTENCA_SQL := C_COLUMN_CONSTRAINTS.COLUMN_NAME;
               ELSE
                  V_SENTENCA_SQL := V_SENTENCA_SQL||', '||C_COLUMN_CONSTRAINTS.COLUMN_NAME;
               END IF;
            END LOOP;

            NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
            V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
            V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);
            INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
            VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'OBJ');

            IF V_CONSTRAINT_TYPE = 'P' THEN
               INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
               VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                      'ALTER TABLE '||P_TABELA||' ADD CONSTRAINT '||V_CONSTRAINT_NAME||' PRIMARY KEY '||'('||V_SENTENCA_SQL||')');
            ELSE
               INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
               VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                      'ALTER TABLE '||P_TABELA||' ADD CONSTRAINT '||V_CONSTRAINT_NAME||' UNIQUE '||'('||V_SENTENCA_SQL||')');
            END IF;
         END LOOP;
         CLOSE CUR_CONSTRAINTS;

         V_SQLOBJETO := 'SELECT CONSTRAINT_NAME, R_CONSTRAINT_NAME, DELETE_RULE '||
                        'FROM USER_CONSTRAINTS ORIGEM '||
                        'WHERE ORIGEM.TABLE_NAME = '''||P_TABELA||''' '||
                        '  AND ORIGEM.CONSTRAINT_TYPE = ''' ||'R'|| ''' '||
                        '  AND NOT EXISTS (SELECT 1 '||
                        '                  FROM USER_CONSTRAINTS@'||P_NMLINKREPLDEST||' DEST '||
                        '                  WHERE DEST.TABLE_NAME = '''||P_TABELA||''' '||
                        '                    AND DEST.CONSTRAINT_NAME = ORIGEM.CONSTRAINT_NAME) ';

         OPEN CUR_CONSTRAINTS FOR V_SQLOBJETO;
         LOOP
            FETCH CUR_CONSTRAINTS INTO V_CONSTRAINT_NAME, V_R_CONSTRAINT_NAME, V_DELETE_RULE;
            EXIT WHEN CUR_CONSTRAINTS%NOTFOUND;
            V_SENTENCA_SQL := NULL;
            V_SENTENCA_SQL_R := NULL;
            FOR C_COLUMN_CONSTRAINTS IN
               (SELECT COLUMN_NAME
                FROM USER_CONS_COLUMNS
                WHERE CONSTRAINT_NAME = V_CONSTRAINT_NAME
                  AND TABLE_NAME = P_TABELA
                ORDER BY USER_CONS_COLUMNS.POSITION)
            LOOP
               IF V_SENTENCA_SQL IS NULL THEN
                  V_SENTENCA_SQL := C_COLUMN_CONSTRAINTS.COLUMN_NAME;
               ELSE
                  V_SENTENCA_SQL := V_SENTENCA_SQL||', '||C_COLUMN_CONSTRAINTS.COLUMN_NAME;
               END IF;
            END LOOP;

            FOR C_COLUMN_CONSTRAINTS_R IN
               (SELECT COLUMN_NAME, TABLE_NAME
                FROM USER_CONS_COLUMNS
                WHERE CONSTRAINT_NAME = V_R_CONSTRAINT_NAME
                ORDER BY USER_CONS_COLUMNS.POSITION)
            LOOP
               IF V_SENTENCA_SQL_R IS NULL THEN
                  V_SENTENCA_SQL_R := C_COLUMN_CONSTRAINTS_R.COLUMN_NAME;
                  V_TABLE_REFERENCES := C_COLUMN_CONSTRAINTS_R.TABLE_NAME;
               ELSE
                  V_SENTENCA_SQL_R := V_SENTENCA_SQL_R||', '||C_COLUMN_CONSTRAINTS_R.COLUMN_NAME;
               END IF;
            END LOOP;

            NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
            V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
            V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);
            INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
            VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'REF');

            IF V_DELETE_RULE = 'CASCADE' THEN
               INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
               VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                      'ALTER TABLE '||P_TABELA||' ADD CONSTRAINT '||V_CONSTRAINT_NAME||' FOREIGN KEY '||'('||V_SENTENCA_SQL||') REFERENCES '||V_TABLE_REFERENCES||'('||V_SENTENCA_SQL_R||') ON DELETE CASCADE');
            ELSE
               INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
               VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                      'ALTER TABLE '||P_TABELA||' ADD CONSTRAINT '||V_CONSTRAINT_NAME||' FOREIGN KEY '||'('||V_SENTENCA_SQL||') REFERENCES '||V_TABLE_REFERENCES||'('||V_SENTENCA_SQL_R||')');
            END IF;
         END LOOP;
         CLOSE CUR_CONSTRAINTS;

         V_SQLOBJETO := 'SELECT INDEX_NAME '||
                        'FROM USER_INDEXES ORIGEM '||
                        'WHERE ORIGEM.TABLE_NAME = '''||P_TABELA||''' '||
                        '  AND ORIGEM.INDEX_NAME NOT LIKE '''||'PK_%'||''' '||
                        '  AND NOT EXISTS (SELECT 1 '||
                        '                  FROM USER_INDEXES@'||P_NMLINKREPLDEST||' DEST '||
                        '                  WHERE DEST.TABLE_NAME = '''||P_TABELA||''' '||
                        '                    AND DEST.INDEX_NAME = ORIGEM.INDEX_NAME) ';

         OPEN CUR_INDEXES FOR V_SQLOBJETO;
         LOOP
            FETCH CUR_INDEXES INTO V_INDEX_NAME;
            EXIT WHEN CUR_INDEXES%NOTFOUND;
            V_SENTENCA_SQL := NULL;
            FOR C_COLUMN_INDEX IN
               (SELECT COLUMN_NAME, DESCEND
                FROM USER_IND_COLUMNS
                WHERE INDEX_NAME = V_INDEX_NAME
                 AND TABLE_NAME = P_TABELA
                ORDER BY COLUMN_POSITION)
            LOOP
               IF V_SENTENCA_SQL IS NULL THEN
                  V_SENTENCA_SQL := C_COLUMN_INDEX.COLUMN_NAME||' '||C_COLUMN_INDEX.DESCEND;
               ELSE
                  V_SENTENCA_SQL := V_SENTENCA_SQL||', '||C_COLUMN_INDEX.COLUMN_NAME||' '||C_COLUMN_INDEX.DESCEND;
               END IF;
            END LOOP;

            NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
            V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
            V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);
            INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
            VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'OBJ');

            INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
            VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB,
                   'CREATE INDEX '||V_INDEX_NAME||' ON '||P_TABELA||'('||V_SENTENCA_SQL||')');
         END LOOP;
         CLOSE CUR_INDEXES;

         INSERT INTO OBJ_ESPELHOTAB(NRSEQESPELHOTAB, NMOBJESPELHOTAB, IDTIPESPELHOTAB)
         VALUES (P_NRSEQESPELHOTAB, P_TABELA, 'DDL');
      END IF;
   ELSE
      V_COUNT := 0;
      SELECT COUNT(1)
      INTO V_COUNT
      FROM OBJ_ESPELHOTAB
      WHERE OBJ_ESPELHOTAB.NRSEQESPELHOTAB = P_NRSEQESPELHOTAB
        AND OBJ_ESPELHOTAB.NMOBJESPELHOTAB = P_TABELA
        AND OBJ_ESPELHOTAB.IDTIPESPELHOTAB = 'DML';

      IF V_COUNT <= 0 THEN
         V_FILTRO_DATA := NULL;
         V_FILTRO_FILIAL := NULL;
         V_SELECT_REGISTRO := NULL;
         V_FILTRO_PK := NULL;
         IF P_TABELASGERAIS = 'N' THEN
            SELECT
               MAX(DSCAMPDTAREANEG), MAX(DSCAMPFILAREANEG)
              INTO V_DSCAMPDTAREANEG, V_DSCAMPFILAREANEG
              FROM TAB_AREANEGOCIO
             WHERE TAB_AREANEGOCIO.NMTABELANEGOCIO = P_TABELA;
            FOR C_CAMPOS_DATA IN
               (SELECT COLUMN_NAME, DATA_TYPE
                FROM USER_TAB_COLUMNS
                WHERE USER_TAB_COLUMNS.TABLE_NAME = P_TABELA
                  AND USER_TAB_COLUMNS.DATA_TYPE <> 'LONG RAW'
                ORDER BY COLUMN_ID
                )
            LOOP
               V_EXECUTAR := 'S';
               IF P_TABELA = 'PARAMGERAL' THEN
                  V_SQLOBJETO := 'SELECT COUNT(*) '||
                                 'FROM PARAMGERAL '||
                                 'WHERE '||C_CAMPOS_DATA.COLUMN_NAME||' IS NOT NULL';
                  OPEN CUR_PARAMGERAL FOR V_SQLOBJETO;
                  FETCH CUR_PARAMGERAL INTO V_COUNT;
                  IF V_COUNT <= 0 THEN
                     V_EXECUTAR := 'N';
                  END IF;
                  CLOSE CUR_PARAMGERAL;
               END IF;
               IF V_EXECUTAR = 'S' THEN
                  IF C_CAMPOS_DATA.DATA_TYPE = 'DATE' THEN
                     IF V_DSCAMPDTAREANEG IS NOT NULL THEN
                        IF (C_CAMPOS_DATA.COLUMN_NAME = V_DSCAMPDTAREANEG) THEN
                           V_FILTRO_DATA := '(('||C_CAMPOS_DATA.COLUMN_NAME||' BETWEEN TO_DATE('''||TO_CHAR(P_DTINICIAL, 'DD/MM/YYYY')||''' '||','||''''||'DD/MM/YYYY'||''' '||')'||' AND TO_DATE('''||TO_CHAR(P_DTFINAL, 'DD/MM/YYYY')||''' '||','||''''||'DD/MM/YYYY'||''' '||')'||')';
                        END IF;
                     ELSE
                        IF V_FILTRO_DATA IS NULL THEN
                           V_FILTRO_DATA := '(('||C_CAMPOS_DATA.COLUMN_NAME||' BETWEEN TO_DATE('''||TO_CHAR(P_DTINICIAL, 'DD/MM/YYYY')||''' '||','||''''||'DD/MM/YYYY'||''' '||')'||' AND TO_DATE('''||TO_CHAR(P_DTFINAL, 'DD/MM/YYYY')||''' '||','||''''||'DD/MM/YYYY'||''' '||')'||')';
                        ELSE
                           V_FILTRO_DATA := V_FILTRO_DATA|| 'OR ('||C_CAMPOS_DATA.COLUMN_NAME||' BETWEEN TO_DATE('''||TO_CHAR(P_DTINICIAL, 'DD/MM/YYYY')||''' '||','||''''||'DD/MM/YYYY'||''' '||')'||' AND TO_DATE('''||TO_CHAR(P_DTFINAL, 'DD/MM/YYYY')||''' '||','||''''||'DD/MM/YYYY'||''' '||')'||')';
                        END IF;
                     END IF;
                  ELSE
                     IF V_DSCAMPFILAREANEG IS NOT NULL THEN
                        IF (C_CAMPOS_DATA.COLUMN_NAME = V_DSCAMPFILAREANEG) THEN
                           FOR C_FILIAL IN
                              (SELECT CDFILIAL
                                 FROM FILESPELHOTAB
                                WHERE FILESPELHOTAB.NRSEQESPELHOTAB = P_NRSEQESPELHOTAB)
                           LOOP
                              IF V_FILTRO_FILIAL IS NULL THEN
                                 V_FILTRO_FILIAL := '(('||C_CAMPOS_DATA.COLUMN_NAME||' = '''||C_FILIAL.CDFILIAL||''' )';
                              ELSE
                                 V_FILTRO_FILIAL := V_FILTRO_FILIAL|| 'OR ('||C_CAMPOS_DATA.COLUMN_NAME||' = '''||C_FILIAL.CDFILIAL||''' )';
                              END IF;
                           END LOOP;
                        END IF;
                     ELSE
                        V_COUNT := 0;
                        SELECT COUNT(1)
                          INTO V_COUNT
                          FROM USER_CONSTRAINTS UC, USER_CONSTRAINTS UCR, USER_CONS_COLUMNS C
                         WHERE UCR.CONSTRAINT_NAME = UC.R_CONSTRAINT_NAME
                           AND UCR.TABLE_NAME = 'FILIAL'
                           AND C.COLUMN_NAME  = C_CAMPOS_DATA.COLUMN_NAME
                           AND UC.TABLE_NAME  = P_TABELA
                           AND UCR.CONSTRAINT_TYPE IN( 'P','U')
                           AND C.CONSTRAINT_NAME = UC.CONSTRAINT_NAME
                           AND C.TABLE_NAME      = UC.TABLE_NAME;
                        IF V_COUNT > 0 THEN
                           FOR C_FILIAL IN
                              (SELECT CDFILIAL
                                 FROM FILESPELHOTAB
                                WHERE FILESPELHOTAB.NRSEQESPELHOTAB = P_NRSEQESPELHOTAB)
                           LOOP
                              IF V_FILTRO_FILIAL IS NULL THEN
                                 V_FILTRO_FILIAL := '(('||C_CAMPOS_DATA.COLUMN_NAME||' = '''||C_FILIAL.CDFILIAL||''' )';
                              ELSE
                                 V_FILTRO_FILIAL := V_FILTRO_FILIAL|| 'OR ('||C_CAMPOS_DATA.COLUMN_NAME||' = '''||C_FILIAL.CDFILIAL||''' )';
                              END IF;
                           END LOOP;
                        END IF;
                     END IF;
                  END IF;
                  IF V_SELECT_REGISTRO IS NULL THEN
                     V_SELECT_REGISTRO := C_CAMPOS_DATA.COLUMN_NAME;
                  ELSE
                     V_SELECT_REGISTRO := V_SELECT_REGISTRO||','||C_CAMPOS_DATA.COLUMN_NAME;
                  END IF;
               END IF;
            END LOOP;
         ELSE
            FOR C_CAMPOS_DATA IN
               (SELECT COLUMN_NAME, DATA_TYPE
                FROM USER_TAB_COLUMNS
                WHERE USER_TAB_COLUMNS.TABLE_NAME = P_TABELA
                  AND USER_TAB_COLUMNS.DATA_TYPE <> 'LONG RAW'
                ORDER BY COLUMN_ID
                )
            LOOP
               V_EXECUTAR := 'S';
               IF P_TABELA = 'PARAMGERAL' THEN
                  V_SQLOBJETO := 'SELECT COUNT(*) '||
                                 'FROM PARAMGERAL '||
                                 'WHERE '||C_CAMPOS_DATA.COLUMN_NAME||' IS NOT NULL';
                  OPEN CUR_PARAMGERAL FOR V_SQLOBJETO;
                  FETCH CUR_PARAMGERAL INTO V_COUNT;
                  IF V_COUNT <= 0 THEN
                     V_EXECUTAR := 'N';
                  END IF;
                  CLOSE CUR_PARAMGERAL;
               END IF;
               IF V_EXECUTAR = 'S' THEN
                  IF (C_CAMPOS_DATA.DATA_TYPE = 'DATE') AND (C_CAMPOS_DATA.COLUMN_NAME LIKE 'DTULTATU%') THEN
                     V_SQLOBJETO := 'SELECT TABLE_NAME '||
                                    'FROM USER_TABLES@'||P_NMLINKREPLDEST||' DEST '||
                                    'WHERE DEST.TABLE_NAME = '''||P_TABELA||''' ';
                     OPEN CUR_TABELAEXISTE FOR V_SQLOBJETO;
                     FETCH CUR_TABELAEXISTE INTO V_SQLOBJETO_TABLE;
                     IF NOT(CUR_TABELAEXISTE%NOTFOUND) THEN
                        V_SQLOBJETO := 'SELECT COLUMN_NAME '||
                                       'FROM USER_TAB_COLUMNS@'||P_NMLINKREPLDEST||' DEST '||
                                       'WHERE DEST.TABLE_NAME = '''||P_TABELA||''' '||
                                       '  AND DEST.COLUMN_NAME = '''||C_CAMPOS_DATA.COLUMN_NAME||''' ';
                        OPEN CUR_ESTRUTURA_COLUMN FOR V_SQLOBJETO;
                        FETCH CUR_ESTRUTURA_COLUMN INTO V_ESTRUTURA_COLUMN_NAME;
                        IF NOT(CUR_ESTRUTURA_COLUMN%NOTFOUND) THEN
                           V_SQLOBJETO := 'SELECT '||C_CAMPOS_DATA.COLUMN_NAME||' '||
                                          'FROM '||P_TABELA||'@'||P_NMLINKREPLDEST||' '||
                                          'WHERE '||C_CAMPOS_DATA.COLUMN_NAME||' IS NOT NULL';
                           OPEN CUR_REGISTROEXISTE FOR V_SQLOBJETO;
                           FETCH CUR_REGISTROEXISTE INTO V_DATA_EXISTE;
                           IF NOT(CUR_REGISTROEXISTE%NOTFOUND) THEN
                              IF V_FILTRO_DATA IS NULL THEN
                                 V_FILTRO_DATA := '(('||C_CAMPOS_DATA.COLUMN_NAME||' > (SELECT MAX('||C_CAMPOS_DATA.COLUMN_NAME||') FROM '||P_TABELA||'@'||P_NMLINKREPLDEST||'))';
                              ELSE
                                 V_FILTRO_DATA := V_FILTRO_DATA|| 'OR ('||C_CAMPOS_DATA.COLUMN_NAME||' > (SELECT MAX('||C_CAMPOS_DATA.COLUMN_NAME||') FROM '||P_TABELA||'@'||P_NMLINKREPLDEST||'))';
                              END IF;
                           END IF;
                           CLOSE CUR_REGISTROEXISTE;
                        END IF;
                        CLOSE CUR_ESTRUTURA_COLUMN;
                     END IF;
                     CLOSE CUR_TABELAEXISTE;
                  END IF;
                  IF V_SELECT_REGISTRO IS NULL THEN
                     V_SELECT_REGISTRO := C_CAMPOS_DATA.COLUMN_NAME;
                  ELSE
                     V_SELECT_REGISTRO := V_SELECT_REGISTRO||','||C_CAMPOS_DATA.COLUMN_NAME;
                  END IF;
               END IF;
            END LOOP;
         END IF;

         IF V_FILTRO_DATA IS NOT NULL THEN
            V_FILTRO_DATA := V_FILTRO_DATA||')';
         END IF;

         IF V_FILTRO_FILIAL IS NOT NULL THEN
            V_FILTRO_FILIAL := V_FILTRO_FILIAL||')';
         END IF;

         FOR C_CAMPOS_PK IN
            (SELECT COLUMN_NAME
             FROM USER_CONSTRAINTS, USER_CONS_COLUMNS
             WHERE USER_CONSTRAINTS.CONSTRAINT_TYPE = 'P'
               AND USER_CONSTRAINTS.CONSTRAINT_NAME = USER_CONS_COLUMNS.CONSTRAINT_NAME
               AND USER_CONSTRAINTS.TABLE_NAME = P_TABELA
               AND USER_CONS_COLUMNS.TABLE_NAME = P_TABELA
               AND USER_CONSTRAINTS.OWNER = USER_CONS_COLUMNS.OWNER)
         LOOP
            IF V_FILTRO_PK IS NULL THEN
               V_FILTRO_PK := 'NOT EXISTS (SELECT 1 FROM '||P_TABELA||'@'||P_NMLINKREPLDEST||' A WHERE A.'||C_CAMPOS_PK.COLUMN_NAME||'= '||P_TABELA||'.'||C_CAMPOS_PK.COLUMN_NAME;
            ELSE
               V_FILTRO_PK := V_FILTRO_PK||' AND '||'A.'||C_CAMPOS_PK.COLUMN_NAME||'= '||P_TABELA||'.'||C_CAMPOS_PK.COLUMN_NAME;
            END IF;
         END LOOP;

         IF V_FILTRO_PK IS NOT NULL THEN
            V_FILTRO_PK := V_FILTRO_PK||')';
         ELSE
            V_SELECT_REGISTRO := NULL;
            V_FILTRO_DATA     := NULL;
            V_FILTRO_FILIAL   := NULL;            
            SELECT
               MAX(DSCAMPDTAREANEG), MAX(DSCAMPFILAREANEG)
              INTO V_DSCAMPDTAREANEG, V_DSCAMPFILAREANEG
              FROM TAB_AREANEGOCIO
             WHERE TAB_AREANEGOCIO.NMTABELANEGOCIO = P_TABELA;
            FOR C_CAMPOS_DATA IN
               (SELECT COLUMN_NAME, DATA_TYPE
                FROM USER_TAB_COLUMNS
                WHERE USER_TAB_COLUMNS.TABLE_NAME = P_TABELA
                  AND USER_TAB_COLUMNS.DATA_TYPE <> 'LONG RAW'                
                ORDER BY COLUMN_ID
                )
            LOOP
               IF C_CAMPOS_DATA.DATA_TYPE = 'DATE' THEN
                  IF V_DSCAMPDTAREANEG IS NOT NULL THEN
                     IF (C_CAMPOS_DATA.COLUMN_NAME = V_DSCAMPDTAREANEG) THEN
                        V_FILTRO_DATA := '(('||C_CAMPOS_DATA.COLUMN_NAME||' BETWEEN TO_DATE('''||TO_CHAR(P_DTINICIAL, 'DD/MM/YYYY')||''' '||','||''''||'DD/MM/YYYY'||''' '||')'||' AND TO_DATE('''||TO_CHAR(P_DTFINAL, 'DD/MM/YYYY')||''' '||','||''''||'DD/MM/YYYY'||''' '||')'||')';
                     END IF;
                  ELSE
                     IF V_FILTRO_DATA IS NULL THEN
                        V_FILTRO_DATA := '(('||C_CAMPOS_DATA.COLUMN_NAME||' BETWEEN TO_DATE('''||TO_CHAR(P_DTINICIAL, 'DD/MM/YYYY')||''' '||','||''''||'DD/MM/YYYY'||''' '||')'||' AND TO_DATE('''||TO_CHAR(P_DTFINAL, 'DD/MM/YYYY')||''' '||','||''''||'DD/MM/YYYY'||''' '||')'||')';
                     ELSE
                        V_FILTRO_DATA := V_FILTRO_DATA|| 'OR ('||C_CAMPOS_DATA.COLUMN_NAME||' BETWEEN TO_DATE('''||TO_CHAR(P_DTINICIAL, 'DD/MM/YYYY')||''' '||','||''''||'DD/MM/YYYY'||''' '||')'||' AND TO_DATE('''||TO_CHAR(P_DTFINAL, 'DD/MM/YYYY')||''' '||','||''''||'DD/MM/YYYY'||''' '||')'||')';
                     END IF;
                  END IF;
               ELSE
                  IF V_DSCAMPFILAREANEG IS NOT NULL THEN
                     IF (C_CAMPOS_DATA.COLUMN_NAME = V_DSCAMPFILAREANEG) THEN
                        FOR C_FILIAL IN
                           (SELECT CDFILIAL
                              FROM FILESPELHOTAB
                             WHERE FILESPELHOTAB.NRSEQESPELHOTAB = P_NRSEQESPELHOTAB)
                        LOOP
                           IF V_FILTRO_FILIAL IS NULL THEN
                              V_FILTRO_FILIAL := '(('||C_CAMPOS_DATA.COLUMN_NAME||' = '''||C_FILIAL.CDFILIAL||''' )';
                           ELSE
                              V_FILTRO_FILIAL := V_FILTRO_FILIAL|| 'OR ('||C_CAMPOS_DATA.COLUMN_NAME||' = '''||C_FILIAL.CDFILIAL||''' )';
                           END IF;
                        END LOOP;
                     END IF;
                  ELSE
                     V_COUNT := 0;
                     SELECT COUNT(1)
                       INTO V_COUNT
                       FROM USER_CONSTRAINTS UC, USER_CONSTRAINTS UCR, USER_CONS_COLUMNS C
                      WHERE UCR.CONSTRAINT_NAME = UC.R_CONSTRAINT_NAME
                        AND UCR.TABLE_NAME = 'FILIAL'
                        AND C.COLUMN_NAME  = C_CAMPOS_DATA.COLUMN_NAME
                        AND UC.TABLE_NAME  = P_TABELA
                        AND UCR.CONSTRAINT_TYPE IN( 'P','U')
                        AND C.CONSTRAINT_NAME = UC.CONSTRAINT_NAME
                        AND C.TABLE_NAME      = UC.TABLE_NAME;
                     IF V_COUNT > 0 THEN
                        FOR C_FILIAL IN
                           (SELECT CDFILIAL
                              FROM FILESPELHOTAB
                             WHERE FILESPELHOTAB.NRSEQESPELHOTAB = P_NRSEQESPELHOTAB)
                        LOOP
                           IF V_FILTRO_FILIAL IS NULL THEN
                              V_FILTRO_FILIAL := '(('||C_CAMPOS_DATA.COLUMN_NAME||' = '''||C_FILIAL.CDFILIAL||''' )';
                           ELSE
                              V_FILTRO_FILIAL := V_FILTRO_FILIAL|| 'OR ('||C_CAMPOS_DATA.COLUMN_NAME||' = '''||C_FILIAL.CDFILIAL||''' )';
                           END IF;
                        END LOOP;
                     END IF;
                  END IF;
               END IF;

               IF V_SELECT_REGISTRO IS NULL THEN
                  V_SELECT_REGISTRO := C_CAMPOS_DATA.COLUMN_NAME;
               ELSE
                  V_SELECT_REGISTRO := V_SELECT_REGISTRO||','||C_CAMPOS_DATA.COLUMN_NAME;
               END IF;
            END LOOP;
            IF V_FILTRO_DATA IS NOT NULL THEN
               V_FILTRO_DATA := V_FILTRO_DATA||')';
            END IF;
            IF V_FILTRO_FILIAL IS NOT NULL THEN
               V_FILTRO_FILIAL := V_FILTRO_FILIAL||')';
            END IF;
         END IF;

         IF V_FILTRO_DATA IS NULL THEN
            V_SQLOBJETO := 'SELECT '||V_SELECT_REGISTRO||' '|| 'FROM '||P_TABELA;
         ELSE
            V_SQLOBJETO := 'SELECT '||V_SELECT_REGISTRO||' '|| 'FROM '||P_TABELA||' WHERE '||V_FILTRO_DATA;
         END IF;

         IF V_FILTRO_FILIAL IS NOT NULL THEN
            IF INSTR(V_SQLOBJETO, 'WHERE') > 0 THEN
               V_SQLOBJETO := V_SQLOBJETO ||' AND '||V_FILTRO_FILIAL;
            ELSE
               V_SQLOBJETO := V_SQLOBJETO ||' WHERE '||V_FILTRO_FILIAL;
            END IF;
         END IF;

         IF V_FILTRO_PK IS NOT NULL THEN
            IF INSTR(V_SQLOBJETO, 'WHERE') > 0 THEN
               V_SQLOBJETO := V_SQLOBJETO||' AND '||V_FILTRO_PK;
            ELSE
               V_SQLOBJETO := V_SQLOBJETO||' WHERE '||V_FILTRO_PK;
            END IF;
         END IF;

         V_SENTENCA_SQL := SUBSTR('INSERT INTO '||P_TABELA||'@'||P_NMLINKREPLDEST||'('||V_SELECT_REGISTRO||') '||V_SQLOBJETO, 1, 6000);

         IF LENGTH(V_SENTENCA_SQL) > 4000 THEN
            IF V_FILTRO_DATA IS NULL THEN
               V_SQLOBJETO := 'SELECT * FROM '||P_TABELA;
            ELSE
               V_SQLOBJETO := 'SELECT * FROM '||P_TABELA||' WHERE '||V_FILTRO_DATA;
            END IF;

            IF V_FILTRO_FILIAL IS NOT NULL THEN
               IF INSTR(V_SQLOBJETO, 'WHERE') > 0 THEN
                  V_SQLOBJETO := V_SQLOBJETO ||' AND '||V_FILTRO_FILIAL;
               ELSE
                  V_SQLOBJETO := V_SQLOBJETO ||' WHERE '||V_FILTRO_FILIAL;
               END IF;
            END IF;

            IF V_FILTRO_PK IS NOT NULL THEN
               IF INSTR(V_SQLOBJETO, 'WHERE') > 0 THEN
                  V_SQLOBJETO := V_SQLOBJETO||' AND '||V_FILTRO_PK;
               ELSE
                  V_SQLOBJETO := V_SQLOBJETO||' WHERE '||V_FILTRO_PK;
               END IF;
            END IF;
            V_SENTENCA_SQL := 'INSERT INTO '||P_TABELA||'@'||P_NMLINKREPLDEST||' '||V_SQLOBJETO;
            V_SENTENCA_SQL := SUBSTR(V_SENTENCA_SQL, 1, 4000);
         END IF;

         NOVO_CODIGO('SQLESPELHOTAB', V_NRSQLPROXIMOCODIGO);
         V_NRSQLPROXIMOCODIGO := SUBSTR(V_NRSQLPROXIMOCODIGO,11,10);
         V_NRSQLESPELHOTAB := TO_NUMBER(V_NRSQLPROXIMOCODIGO);
         INSERT INTO PARAMSQLESPTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,IDSQLESPELHOTAB, IDTIPOSQLESPTAB)
         VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, 'P', 'DML');

         INSERT INTO SQL_ESPELHOTAB (NRSEQESPELHOTAB,NRSQLESPELHOTAB,DSCOMANDOSQLTAB)
         VALUES(P_NRSEQESPELHOTAB, V_NRSQLESPELHOTAB, V_SENTENCA_SQL);

         INSERT INTO OBJ_ESPELHOTAB(NRSEQESPELHOTAB, NMOBJESPELHOTAB, IDTIPESPELHOTAB)
         VALUES (P_NRSEQESPELHOTAB, P_TABELA, 'DML');

         IF P_TABELASGERAIS = 'N' THEN
            FOR C_TABELAS_FILHAS_REGISTROS IN
               (SELECT DISTINCT
                   UC.TABLE_NAME AS TABLE_NAME
                FROM USER_CONSTRAINTS UC, USER_CONSTRAINTS UCR
                WHERE UCR.CONSTRAINT_NAME = UC.R_CONSTRAINT_NAME
                  AND UCR.TABLE_NAME = P_TABELA
                  AND UCR.CONSTRAINT_TYPE IN( 'P','U')
                  AND UC.TABLE_NAME <> P_TABELA
                  AND NOT EXISTS (SELECT 1
                                  FROM USER_TAB_COLUMNS, USER_CONS_COLUMNS
                                  WHERE USER_TAB_COLUMNS.TABLE_NAME = UC.TABLE_NAME
                                    AND USER_TAB_COLUMNS.COLUMN_NAME = USER_CONS_COLUMNS.COLUMN_NAME
                                    AND USER_CONS_COLUMNS.TABLE_NAME = UC.TABLE_NAME
                                    AND USER_CONS_COLUMNS.CONSTRAINT_NAME = UC.CONSTRAINT_NAME
                                    AND USER_CONS_COLUMNS.OWNER = UC.OWNER
                                    AND USER_TAB_COLUMNS.NULLABLE = 'Y'))
            LOOP
               OPERACAO_TABELA_BACKUP(P_NRSEQESPELHOTAB, C_TABELAS_FILHAS_REGISTROS.TABLE_NAME, P_NMLINKREPLDEST, P_IDLIMPARTABDEST, 'S', P_DTINICIAL, P_DTFINAL, P_TABELASGERAIS);
            END LOOP;
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('OPERACAO_TABELA_BACKUP','5.09.000'); END;
/

