var Bco54500_Conciliacao_Controller = function(ScreenService, General, Bco54500_Conciliacao_Service, templateManager, ZHPromise, ZhFilterPreferences) {

    var self = this;
    var statusMovbancario = '';
    var statusExtrato = '';
    
    self.openFilterConciliacao = function(widget){
        widget.activate();
        ZhFilterPreferences.setOriginalFilter(widget.id);
        ZhFilterPreferences.openFilterWidget(widget);  
    };

    self.atualizaTabbeds = function(conciliacao, preference, widget_name) {
        self.setDataSourceFilterTabbeds(preference).then(function() {
			self.setContaCorrente(preference);
			var extrato   = templateManager.container.getWidget('extrato_bancario');
            var movimento = templateManager.container.getWidget('movimentacao_bancaria');
            
            extrato.activate();
            extrato.getAction('CONCILIAR').isVisible = false;
            extrato.getAction('DESCONCILIAR').isVisible = false;
            
            movimento.activate();
            movimento.getAction('CONCILIAR').isVisible = false;
            movimento.getAction('DESCONCILIAR').isVisible = false;
        });
        
        self.atualizaWidgets(widget_name);
    };
    
    self.atualizaWidgets = function(widget_name) {
        var widget = templateManager.container.getWidget(widget_name);
        widget.reload();
    };

    self.setContaCorrente = function(popup) {
        var widget = templateManager.container.getWidget('conciliacao');
        
        widget.currentRow.CDREDUCONT = popup.FILTER_ROW.CDREDUCONT;
        widget.currentRow.CDCONTCORR = popup.FILTER_ROW.CDCONTCORR;
        widget.currentRow.CDBANCO    = popup.FILTER_ROW.CDBANCO;
        widget.currentRow.CDAGENCIA  = popup.FILTER_ROW.CDAGENCIA;
        widget.currentRow.DSCONTCORR = popup.FILTER_ROW.DSCONTCORR;
        
        var currentRow = {
            cdreducont : widget.currentRow.CDREDUCONT,
            datarefe   : moment().format('DD/MM/YYYY')
        };
        
        Bco54500_Conciliacao_Service.getSaldoContaCorr(currentRow).then(function(saldo_contacorr) {
            widget.currentRow.SALDO = saldo_contacorr.dataset.getSaldoContaCorr.SALDO;
        });
    };

    self.setDataSourceFilterTabbeds = function (popupFilter) {
        var deferred = ZHPromise.defer();
        var extrato = templateManager.container.getWidget('extrato_bancario');
        var sistema = templateManager.container.getWidget('movimentacao_bancaria');
        var dtmovreal    = false;
        var dtmovbanc    = false;
        
        if (popupFilter.FILTER_ROW.hasOwnProperty('DTMOVREAL'))
            if (popupFilter.FILTER_ROW.DTMOVREAL.hasOwnProperty('start') && (popupFilter.FILTER_ROW.DTMOVREAL.start))
                dtmovreal = true;
                
        if (popupFilter.FILTER_ROW.hasOwnProperty('DTMOVBANC'))
            if (popupFilter.FILTER_ROW.DTMOVBANC.hasOwnProperty('start') && (popupFilter.FILTER_ROW.DTMOVBANC.start))
                dtmovbanc = true;
                
        for(var i = extrato.dataSourceFilter.length - 1; i >= 0; i--){
            if (extrato.dataSourceFilter[i].name === 'NRMOVBARE')
                extrato.dataSourceFilter.splice(i, 1);
            else if (extrato.dataSourceFilter[i].name === 'NRCONCIMOVB')
                extrato.dataSourceFilter.splice(i, 1);
        }
        extrato.dataSource.clearCheckedRows();
        
        for(var y = sistema.dataSourceFilter.length - 1; y >= 0; y--){
            if (sistema.dataSourceFilter[y].name === 'NRSEQMOVREBA')
                sistema.dataSourceFilter.splice(y, 1);
            else if (sistema.dataSourceFilter[y].name === 'CDSEQUEXBA')
                sistema.dataSourceFilter.splice(y, 1);
            else if (sistema.dataSourceFilter[y].name === 'NRCONCIMOVB')
                sistema.dataSourceFilter.splice(y, 1);
        }
        sistema.dataSource.clearCheckedRows();
        
        extrato.dataSourceFilter.forEach(function(filter) {
            switch(filter.name) {
                case 'CDREDUCONT': filter.value = (popupFilter.FILTER_ROW.CDREDUCONT) ? popupFilter.FILTER_ROW.CDREDUCONT : null;
                    break;
                case 'DTINICIAL': filter.value = (dtmovreal) ? popupFilter.FILTER_ROW.DTMOVREAL.start : null;
                    break;
                case 'DTFINAL': filter.value = (dtmovreal) ? popupFilter.FILTER_ROW.DTMOVREAL.end : null;
                    break;
                case 'TDATAS': filter.value = (dtmovreal) ? null : 'T';
                    break;
                case 'NRDOC': filter.value = (popupFilter.FILTER_ROW.NRDOC) ? popupFilter.FILTER_ROW.NRDOC : 'T';
                    break;
                case 'VALOR': filter.value = (popupFilter.FILTER_ROW.VALOR == 0) ? null : popupFilter.FILTER_ROW.VALOR;
                    break;
                case 'TVALOR': filter.value = ((popupFilter.FILTER_ROW.VALOR == 0) || (popupFilter.FILTER_ROW.VALOR == null)) ? 'T' : null;
                    break;
                case 'IDSTATUSEXTRATO': filter.value = (popupFilter.FILTER_ROW.IDSTATUSEXTRATO) ? popupFilter.FILTER_ROW.IDSTATUSEXTRATO : 'T';
                    break;
                case 'IDMOVREAL': filter.value = (popupFilter.FILTER_ROW.IDMOVREAL) ? popupFilter.FILTER_ROW.IDMOVREAL : 'T';
                    break;
                default: break;
            }
        });

        sistema.dataSourceFilter.forEach(function(filter) {
            switch(filter.name) {
                case 'CDREDUCONT': filter.value = (popupFilter.FILTER_ROW.CDREDUCONT) ? popupFilter.FILTER_ROW.CDREDUCONT : null;
                    break;
                case 'DTINICIAL': filter.value = (dtmovbanc) ? popupFilter.FILTER_ROW.DTMOVBANC.start : null;
                    break;
                case 'DTFINAL': filter.value = (dtmovbanc) ? popupFilter.FILTER_ROW.DTMOVBANC.end : null;
                    break;
                case 'NRDOCMBANC': filter.value = (popupFilter.FILTER_ROW.NRDOCMBANC) ? popupFilter.FILTER_ROW.NRDOCMBANC : null;
                    break;
                case 'VALORBANC': filter.value = (popupFilter.FILTER_ROW.VALORBANC == 0) ? null : popupFilter.FILTER_ROW.VALORBANC;
                    break;
                case 'IDSTATUSBANC': filter.value = (popupFilter.FILTER_ROW.IDSTATUSBANC) ? popupFilter.FILTER_ROW.IDSTATUSBANC : 'T';
                    break;
                case 'IDMOVBANC': filter.value = (popupFilter.FILTER_ROW.IDMOVBANC) ? popupFilter.FILTER_ROW.IDMOVBANC : 'T';
                    break;
                default: break;
            }
        });
        
        deferred.resolve();
        return deferred.promise;
    };
    
    self.retornaAoFiltro = function (reload) {
        var deferred = ZHPromise.defer();
        
        var conciliacao = templateManager.container.getWidget('conciliacao');
        var extrato     = templateManager.container.getWidget('extrato_bancario');
        var movimento   = templateManager.container.getWidget('movimentacao_bancaria');
        
        conciliacao.currentRow.VALORMOVBANC = 0;
        conciliacao.currentRow.VALOREXTRATO = 0;
        
        extrato.getAction('DESCONCILIAR').isVisible = false;
        movimento.getAction('DESCONCILIAR').isVisible = false;
        
        for(var i = extrato.dataSourceFilter.length - 1; i >= 0; i--){
            if (extrato.dataSourceFilter[i].name === 'NRMOVBARE')
                extrato.dataSourceFilter.splice(i, 1);
            else if (extrato.dataSourceFilter[i].name === 'NRCONCIMOVB')
                extrato.dataSourceFilter.splice(i, 1);
        }
        extrato.dataSource.clearCheckedRows();
        
        for(var y = movimento.dataSourceFilter.length - 1; y >= 0; y--){
            if (movimento.dataSourceFilter[y].name === 'NRSEQMOVREBA')
                movimento.dataSourceFilter.splice(y, 1);
            else if (movimento.dataSourceFilter[y].name === 'CDSEQUEXBA')
                movimento.dataSourceFilter.splice(y, 1);
            else if (movimento.dataSourceFilter[y].name === 'NRCONCIMOVB')
                movimento.dataSourceFilter.splice(y, 1);
        }
        movimento.dataSource.clearCheckedRows();
        
        if(reload){
            movimento.reload();
            extrato.reload();
        }
        
        deferred.resolve();
        return deferred;
    };

    self.conciliarExtratosMovimentos = function() {
        var conciliacao = templateManager.container.getWidget('conciliacao');
        var valorExtrato = parseFloat(conciliacao.getField('VALOREXTRATO').value().toFixed(2));
        var valorMovbanc = parseFloat(conciliacao.getField('VALORMOVBANC').value().toFixed(2));
        
        if (valorExtrato == valorMovbanc) {
            
            var movimentos = templateManager.container.getWidget('movimentacao_bancaria');
            var extrato = templateManager.container.getWidget('extrato_bancario');
            var dataSet = [];
            var route = 'fin_movimentacaoBancaria#/conciliarExtratosMovimentos';
            var dataExtrato = extrato.getCheckedRows();
            var dataMovimentos = movimentos.getCheckedRows();
            var message = '';
            
            if ((dataExtrato.length + dataMovimentos.length) == 2) {
                if (dataExtrato[0].NRDOCMOVREAL != dataMovimentos[0].NRDOCMBANC)
                    message += 'Nº do documento do extrato está diferente do nº do documento da movimentação bancária.\n';
                    
                if (dataExtrato[0].DTMOVREAL != dataMovimentos[0].DTMOVBANC)
                    message += 'Data do extrato está diferente da data da movimentação bancária.';
            }
            
            if (message != '') {
                ScreenService.confirmMessage(message + '\nDeseja confirmar?', 'question', function (success) {
                    self.request(dataSet, dataExtrato, dataMovimentos, route).then(function() {
                        extrato.unSelectAll();
                        movimentos.unSelectAll();
                        ScreenService.showMessage('Conciliação realizada com sucesso.');
                        ScreenService.closePopup();
                        self.retornaAoFiltro(true);
                    });
                });
            }else{
                self.request(dataSet, dataExtrato, dataMovimentos, route).then(function() {
                    extrato.unSelectAll();
                    movimentos.unSelectAll();
                    ScreenService.showMessage('Conciliação realizada com sucesso.');
                    ScreenService.closePopup();
                    
                    self.retornaAoFiltro(true);
                });
            }

        }else ScreenService.showMessage('Operação bloqueada. Valores totais de extratos e movimentações diferentes.');
    };

    self.desconciliarExtratosMovimentos = function(widget) {
        ScreenService.confirmMessage('Deseja realmente desconciliar os extratos e movimentações exibidos?', 'question',
            function () {
                var conciliacao = templateManager.container.getWidget('conciliacao');
                var extrato     = templateManager.container.getWidget('extrato_bancario');
                var movimentos  = templateManager.container.getWidget('movimentacao_bancaria');
                
                var dataSet = [];
                var route   = 'fin_movimentacaoBancaria#/desconciliarExtratosMovimentos';
                
                self.request(dataSet, extrato.dataSource.data, movimentos.dataSource.data, route).then(function() {
                    ScreenService.showMessage('Desconciliação realizada com sucesso.');
                    ScreenService.closePopup();
                    
                    self.setDataSourceFilterTabbeds(movimentos.appliedFilter).then(function() {
                        movimentos.reload();
                        extrato.reload();
                        
                        extrato.getAction('DESCONCILIAR').isVisible = false;
                        movimentos.getAction('DESCONCILIAR').isVisible = false;
                    });
                });
            }
        );
        

    };

    self.request = function(dataSet, dataExtrato, dataMovimentos, route) {
        var deferred = ZHPromise.defer();
        
        for (var i = 0; i < dataExtrato.length; i++)
            dataSet[dataSet.length] = dataExtrato[i];
            
        for (var j = 0; j < dataMovimentos.length; j++)
            dataSet[dataSet.length] = dataMovimentos[j];
            
        dataSet[0].QTDEEXTRATO = dataExtrato.length;
        
        General.callRestEngine(route, 'DataSet', dataSet)
            .then(function () {
                deferred.resolve();
            })
            .catch(function (erro) {
                deferred.reject();
            }
        );

        return deferred;
    };

    self.validaCheckExtrato = function() {
        var conciliacao = templateManager.container.getWidget('conciliacao');
        var extrato     = templateManager.container.getWidget('extrato_bancario');
        var movimentos  = templateManager.container.getWidget('movimentacao_bancaria');
        
        var hash = null;
        var soma = 0;
        
        var idstconext = (movimentos.getCheckedRows().length > 0)?movimentos.getCheckedRows()[0].IDSTCONEXT:extrato.getLastSelectedRow().IDSTCONMVBAN;
        
        if ((extrato.getCheckedRows().length > 1) && (extrato.getCheckedRows()[0].IDSTCONMVBAN != extrato.getLastSelectedRow().IDSTCONMVBAN)) {
            ScreenService.showMessage('Operação bloqueada. Extratos devem possuir o mesmo status.');
            extrato.getLastSelectedRow().__isSelected = false;
            hash = self.getHashKey(extrato, extrato.getLastSelectedRow());
			delete extrato.dataSource.checkedRowsCache[hash];
            extrato.dataSource.updateCheckedRows();
        } else if ((extrato.getCheckedRows()) && (movimentos.getCheckedRows()) && (idstconext != extrato.getLastSelectedRow().IDSTCONMVBAN)) {
            ScreenService.showMessage('Operação bloqueada. Extratos devem possuir o mesmo status das movimentações.');
            extrato.getLastSelectedRow().__isSelected = false;
            hash = self.getHashKey(extrato, extrato.getLastSelectedRow());
            delete extrato.dataSource.checkedRowsCache[hash];
            extrato.dataSource.updateCheckedRows();
        } else {
            statusExtrato = extrato.getLastSelectedRow().IDSTCONMVBAN;

            // Cálculo do Valor Total de Extratos
            extrato.getCheckedRows().forEach(function (data) {
                if (data.IDSTCONMVBAN.toString() == '0') {
                    soma += (data.IDMOVREAL == 'C')?parseFloat(data.VRMOVREAL):parseFloat(data.VRMOVREAL)*-1;
                }
            });
            conciliacao.currentRow.VALOREXTRATO = soma;
            
            if (extrato.getLastSelectedRow().IDSTCONMVBAN == '1') {
                extrato.filterData = angular.copy(extrato.dataSource.data);
                if((extrato.getCheckedRows().length < 2) && ((movimentos.getCheckedRows().length == 0) || movimentos.getCheckedRows().length == 'undefined'))
                    self.reloadExtratoMovimentos(extrato, extrato.getLastSelectedRow().NRCONCIMOVB);
            }else{
                if(movimentos.getCheckedRows().length > 0){
                    extrato.activate();
                    extrato.getAction('CONCILIAR').isVisible = true;
                    extrato.getAction('DESCONCILIAR').isVisible = false;
                }
            }
        }
    };

    self.getHashKey = function(widget, row) {
        var VO = widget.dataSource.getVO();
        var hash = "";
        if (VO && VO.localKey) {
            hash = VO.localKey.reduce(function(hash, key) {
                return row[key] ? hash + "_" + row[key].toString() : hash;
            }, "");
        }
        return hash;
    };

    self.validaCheckMovimentos = function() {
        var conciliacao = templateManager.container.getWidget('conciliacao');
        var movimentos  = templateManager.container.getWidget('movimentacao_bancaria');
        var extrato     = templateManager.container.getWidget('extrato_bancario');
        
        var soma = 0;
        var hash;
        
        var idstconmvban = (extrato.getCheckedRows().length > 0)?extrato.getCheckedRows()[0].IDSTCONMVBAN:movimentos.getLastSelectedRow().IDSTCONEXT;
        
        if ((movimentos.getCheckedRows().length > 1) && (movimentos.getCheckedRows()[0].IDSTCONEXT != movimentos.getLastSelectedRow().IDSTCONEXT)) {
            ScreenService.showMessage('Operação bloqueada. Movimentos devem possuir o mesmo status');
            movimentos.getLastSelectedRow().__isSelected = false;
            hash = self.getHashKey(movimentos, movimentos.getLastSelectedRow());
            delete movimentos.dataSource.checkedRowsCache[hash];
            movimentos.dataSource.updateCheckedRows();
        } else if ((extrato.getCheckedRows()) && (movimentos.getCheckedRows()) && (idstconmvban != movimentos.getLastSelectedRow().IDSTCONEXT)) {
            ScreenService.showMessage('Operação bloqueada. Movimentações devem possuir o mesmo status dos extratos.');
            movimentos.getLastSelectedRow().__isSelected = false;
            hash = self.getHashKey(movimentos, movimentos.getLastSelectedRow());
            delete movimentos.dataSource.checkedRowsCache[hash];
            movimentos.dataSource.updateCheckedRows();
        } else {
            statusMovbancario = movimentos.getLastSelectedRow().IDSTCONEXT;

            movimentos.getCheckedRows().forEach(function (data) {
                if (data.IDSTCONEXT.toString() == '0')
                    soma += (data.IDMOVBANC == 'C')?parseFloat(data.VRMOVBANC):parseFloat(data.VRMOVBANC)*-1;
            });
            conciliacao.currentRow.VALORMOVBANC = soma;
            
            if (movimentos.getLastSelectedRow().IDSTCONEXT == '1') {
                movimentos.filterData = angular.copy(movimentos.dataSource.data);
                if((movimentos.getCheckedRows().length < 2) && ((extrato.getCheckedRows().length == 0) || extrato.getCheckedRows().length == 'undefined'))
                    self.reloadExtratoMovimentos(movimentos, movimentos.getLastSelectedRow().NRCONCIMOVB);
            }else{
                if(extrato.getCheckedRows().length > 0){
                    movimentos.activate();
                    movimentos.getAction('CONCILIAR').isVisible = true;
                    movimentos.getAction('DESCONCILIAR').isVisible = false;
                }
            }
        }
    };

    self.reloadExtratoMovimentos = function(widget, numeroConciliacao) {
        var extrato    = templateManager.container.getWidget('extrato_bancario');
        var movimentos = templateManager.container.getWidget('movimentacao_bancaria');
        
        extrato.getAction('CONCILIAR').isVisible = false;
        extrato.getAction('DESCONCILIAR').isVisible = true;
        movimentos.getAction('CONCILIAR').isVisible = false;
        movimentos.getAction('DESCONCILIAR').isVisible = true;
        
        var extCamposNulos = ['DTINICIAL', 'DTFINAL', 'VALOR'];
        extrato.filtroAntigo = angular.copy(extrato.dataSourceFilter);
        extrato.dataSourceFilter.forEach(function(filter) {
            if (filter.name != 'CDREDUCONT') {
                filter.value = (extCamposNulos.indexOf(filter.name) != -1) ? null : 'T';
            }
        });
        
        var nrmovbare = (widget.name == 'extrato_bancario') ? widget.getLastSelectedRow().NRMOVBARE : widget.getLastSelectedRow().NRMOVBANC;
        
        if (!numeroConciliacao) {
            extrato.dataSourceFilter.push({name: 'NRMOVBARE', operator: '=', value: nrmovbare});
        }else{
            extrato.dataSourceFilter.push({name: 'NRCONCIMOVB', operator: '=', value: widget.getLastSelectedRow().NRCONCIMOVB});
        }
        
        var movCamposNulos = ['DTINICIAL', 'DTFINAL', 'VALORBANC'];
        movimentos.filtroAntigo = angular.copy(movimentos.dataSourceFilter);
        movimentos.dataSourceFilter.forEach(function(filter) {
            if (filter.name != 'CDREDUCONT') {
                filter.value = (movCamposNulos.indexOf(filter.name) != -1) ? null : 'T';
            }
        });
        
        var nrseqmovreba = (widget.name == 'extrato_bancario') ? widget.getLastSelectedRow().NRSEQMOVREAL : widget.getLastSelectedRow().NRSEQMOVREBA;
        var cdsequexba = (widget.name == 'extrato_bancario') ? widget.getLastSelectedRow().CDSEQUEXTR : widget.getLastSelectedRow().CDSEQUEXBA;
        
        if (!numeroConciliacao) {
            movimentos.dataSourceFilter.push({name: 'NRSEQMOVREBA', operator: '=', value: nrseqmovreba});
            movimentos.dataSourceFilter.push({name: 'CDSEQUEXBA', operator: '=', value: cdsequexba});
        }else{
            movimentos.dataSourceFilter.push({name: 'NRCONCIMOVB', operator: '=', value: widget.getLastSelectedRow().NRCONCIMOVB});
        }
    
        movimentos.reload();
        extrato.reload();
    };

    self.validaExtratoSelectAll = function(extrato) {
        var conciliacao = templateManager.container.getWidget('conciliacao');
        var movimentos = templateManager.container.getWidget('movimentacao_bancaria');
        var naoconciliado = false;
        var conciliado = false;
        var valorextrato = 0;
        
        extrato.getCheckedRows().forEach(function (data) {
            if(data.IDSTCONMVBAN == 0){
                naoconciliado = true;
                valorextrato += (data.IDMOVREAL == 'C')?parseFloat(data.VRMOVREAL):parseFloat(data.VRMOVREAL)*-1;
            }else conciliado = true;
        });
        
        if(conciliado && naoconciliado){
            extrato.dataSource.unSelectAll();
            ScreenService.confirmMessage('Somente é possivel marcar extratos não conciliados. Deseja marcá-los?', 'question',
                function () {
                    var a = extrato.dataSource.data.filter(function(data){
                        return data.IDSTCONMVBAN == 0;
                    });
                    extrato.dataSource.selectAll(a);
                    statusExtrato = '0';
                    conciliacao.currentRow.VALOREXTRATO = valorextrato;
                    if(movimentos.getCheckedRows().length > 0){
                        extrato.activate();
                        extrato.getAction('CONCILIAR').isVisible = true;
                        movimentos.getAction('CONCILIAR').isVisible = true;
                    }
                    templateManager.updateTemplate();
                }
                
            );
        }else if(conciliado && !naoconciliado){
            extrato.dataSource.unSelectAll();
            ScreenService.showMessage('Operação bloqueada. Não há extratos não conciliados para marcação.');
        }else{
            statusExtrato = '0';
            if(movimentos.getCheckedRows().length > 0){
                extrato.activate();
                extrato.getAction('CONCILIAR').isVisible = true;
                movimentos.getAction('CONCILIAR').isVisible = true;
            }
            conciliacao.currentRow.VALOREXTRATO = valorextrato;
        }
    };
    
    self.validaMovimentosSelectAll = function(movimentos) {
        var conciliacao = templateManager.container.getWidget('conciliacao');
        var extrato    = templateManager.container.getWidget('extrato_bancario');
        var naoconciliado = false;
        var conciliado = false;
        var valormovbanc = 0;
        
        movimentos.getCheckedRows().forEach(function (data) {
            if(data.IDSTCONEXT == 0){
                naoconciliado = true;
                valormovbanc += (data.IDMOVBANC == 'C')?parseFloat(data.VRMOVBANC):parseFloat(data.VRMOVBANC)*-1;
            }else conciliado = true;
        });
        
        if(conciliado && naoconciliado){
            movimentos.dataSource.unSelectAll();
            ScreenService.confirmMessage('Somente é possivel marcar movimentos não conciliados. Deseja marcá-los?', 'question',
                function () {
                    var a = movimentos.dataSource.data.filter(function(data){
                        return data.IDSTCONEXT == 0;
                    });
                    movimentos.dataSource.selectAll(a);
                    statusMovbancario = '0';
                    if(extrato.getCheckedRows().length > 0){
                        movimentos.activate();
                        extrato.getAction('CONCILIAR').isVisible = true;
                        movimentos.getAction('CONCILIAR').isVisible = true;
                    }
                    conciliacao.currentRow.VALORMOVBANC = valormovbanc;
                    templateManager.updateTemplate();
                }
                
            );
        }else if(conciliado && !naoconciliado){
            movimentos.dataSource.unSelectAll();
            ScreenService.showMessage('Operação bloqueada. Não há movimentos não conciliados para marcação.');
        }else{
            statusMovbancario = '0';
            if(extrato.getCheckedRows().length > 0){
                movimentos.activate();
                extrato.getAction('CONCILIAR').isVisible = true;
                movimentos.getAction('CONCILIAR').isVisible = true;
            }
            conciliacao.currentRow.VALORMOVBANC = valormovbanc;
        }
    };

    self.validaUnselectAll = function(widget) {
        var conciliacao = templateManager.container.getWidget('conciliacao');
        var extrato = templateManager.container.getWidget('extrato_bancario');
        var movimentos = templateManager.container.getWidget('movimentacao_bancaria');
        var widget_active = templateManager.container.getActiveWidget();
        
        if((widget_active.name == 'extrato_bancario') || (widget_active.name == 'movimentacao_bancaria')){
            
            extrato.getAction('CONCILIAR').isVisible = false;
            extrato.getAction('DESCONCILIAR').isVisible = false;
            movimentos.getAction('CONCILIAR').isVisible = false;
            movimentos.getAction('DESCONCILIAR').isVisible = false;
            
            if(widget.name == 'extrato_bancario'){
                statusExtrato = '';
                conciliacao.currentRow.VALOREXTRATO = 0;
            }else{
                statusMovbancario = '';
                conciliacao.currentRow.VALORMOVBANC = 0;
            }
            
            if((extrato.getLastSelectedRow().IDCONCREAL) || (movimentos.getLastSelectedRow().IDCONCBANC)){
                var checkeds = extrato.getCheckedRows().length + movimentos.getCheckedRows().length;
                if (checkeds == 0) {
                    self.setDataSourceFilterTabbeds(movimentos.appliedFilter).then(function() {
                        movimentos.reload();
                        extrato.reload();
                    });
                }
            }
        }
    };

    self.validaUnselectRow = function(widget) {
        var conciliacao = templateManager.container.getWidget('conciliacao');
        var extrato = templateManager.container.getWidget('extrato_bancario');
        var movimentos = templateManager.container.getWidget('movimentacao_bancaria');
        var somaExt = 0;
        var somaMov = 0;
        
        // Status do Extrato e Movimentação
        if (widget.getCheckedRows().length == 0) {
            statusExtrato = (widget.name == extrato.name) ? '' : statusExtrato;
            statusMovbancario = (widget.name == movimentos.name) ? '' : statusMovbancario;
        }
        
        // Filtro de Conciliação
        if((extrato.getLastSelectedRow().IDCONCREAL) || (movimentos.getLastSelectedRow().IDCONCBANC)){
            var checkeds = extrato.getCheckedRows().length + movimentos.getCheckedRows().length;
            if (checkeds == 0) {
                self.setDataSourceFilterTabbeds(movimentos.appliedFilter).then(function() {
                    movimentos.reload();
                    extrato.reload();
                });
                
                extrato.getAction('CONCILIAR').isVisible = false;
                extrato.getAction('DESCONCILIAR').isVisible = false;
                movimentos.getAction('CONCILIAR').isVisible = false;
                movimentos.getAction('DESCONCILIAR').isVisible = false;
            }
        }else{

            // Calcula Valor
            if (widget.name == movimentos.name) {
                movimentos.getCheckedRows().forEach(function (data) {
                    somaMov += (data.IDMOVBANC == 'C')?parseFloat(data.VRMOVBANC):parseFloat(data.VRMOVBANC)*-1;
                });
                conciliacao.currentRow.VALORMOVBANC = somaMov;
            }
            if (widget.name == extrato.name) {
                extrato.getCheckedRows().forEach(function (data) {
                    somaExt += (data.IDMOVREAL == 'C')?parseFloat(data.VRMOVREAL):parseFloat(data.VRMOVREAL)*-1;
                });
                conciliacao.currentRow.VALOREXTRATO = somaExt;
            }
            
            if ((extrato.getCheckedRows().length == 0) || (movimentos.getCheckedRows().length == 0)){
                extrato.getAction('CONCILIAR').isVisible = false;
                extrato.getAction('DESCONCILIAR').isVisible = false;
                movimentos.getAction('CONCILIAR').isVisible = false;
                movimentos.getAction('DESCONCILIAR').isVisible = false;
            }
            
            
        }
    };

    ////////////////////////////// Conciliação Automática //////////////////////////////////////////

    /**
     * Essa função é responsável por chamar a requisição que fara a conciliação automática.
     * É montado um array de um objeto que contém os parametros passado pelo usuário. Quando
     * o usuário não seleciona uma data, a propriedade TDTCONCILIA é passada como 'T', quando
     * ele seleciona uma data é passado null. Ela é responsável, também, por tratar o retorno
     * deste request.
     *
     * @param  {Object} widget widget do popup da cociliação automática
     */
    self.conciliaMovs = function(widget) {
        if(widget.isValid()) {
            var movimentos = templateManager.container.getWidget('movimentacao_bancaria');
            var extratos   = templateManager.container.getWidget('extrato_bancario');
            
            var row = [{
                "NRDIA": widget.currentRow.NRDIA,
                "CDREDUCONT": widget.currentRow.CDREDUCONT,
                "DTCONCILIA": widget.currentRow.DTCONCILIA ? widget.currentRow.DTCONCILIA : null,
                "TDTCONCILIA": widget.currentRow.DTCONCILIA ? null : 'T'
            }];
            General.callRestEngine('fin_movimentacaoBancaria#/conciliacaoAutomatica', 'Row', row).then(function (success) {
                ScreenService.showMessage(success.messages[0].message);
                self.setDataSourceFilterTabbeds(movimentos.appliedFilter).then(function() {
                    movimentos.reload();
                    extratos.reload();
                    ScreenService.closePopup();
                });
            }).catch(function (error) {
                if(error.data)
                     ScreenService.showMessage(error.data.error);
                else ScreenService.showMessage(error);
            }
        );
        }
    };

    /**
     * Essa função tem como objetivo setar a correnteRow da widget, da rotina de conciliação automática,
     * com os campos de CDREDUCONT, necessário para a rotina, e DSCONTCORR que é necessário para exibição
     * no campo de conta corrente. Esses valores só são setado se o usuário tiver filtrado a tela, e por
     * isso a widget de conciliação manual tiver o campo de CDREDUCONT, que também é necessário para o
     * seu processo.
     *
     * @param  {Object} widgetPopup widget do popup de conciliação automática
     */
    self.getContaCorrente = function(widgetPopup) {
        var widgetConciliManual = templateManager.container.getWidget('conciliacao');
        var currentRow = widgetConciliManual.currentRow;

        if(currentRow.CDREDUCONT) {
            widgetPopup.currentRow.CDREDUCONT = currentRow.CDREDUCONT;
            widgetPopup.currentRow.DSCONTCORR = currentRow.DSCONTCORR;
        }
    };

};
Configuration(function (ContextRegister) {
    ContextRegister.register('Bco54500_Conciliacao_Controller', Bco54500_Conciliacao_Controller);
});